//SDrain.cs



datablock ExplosionData(SDrainExplosion : SLaserExplosion)
{
   //explosionShape = "";
   //lifeTimeMS = 500;

   //impulse
   impulseRadius = 0.9;
   impulseForce = 1000;

damageRadius = 0.0;
   radiusDamage = 0;

};
//projectile
AddDamageType("SDrain",   '\c0%1 \c1ate hammer.',    '\c0%1\c1 took a hammer to the face from \c0%2',1,1);
datablock ProjectileData(SDrainProjectile)
{
   //projectileShapeName = "~/data/shapes/arrow.dts";
   directDamage        = 5;
   directDamageType  = $DamageType::SDrain;
   radiusDamageType  = $DamageType::SDrain;
   explosion           = SDrainExplosion;
   //particleEmitter     = as;

   muzzleVelocity      = 75;
   velInheritFactor    = 1;

   impactImpulse	     = 300;
   verticalImpulse	  = 300;

   armingDelay         = 0;
   lifetime            = 140;
   fadeDelay           = 70;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";
};


//////////
// item //
//////////
datablock ItemData(SDrainItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "base/data/shapes/hammer.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "SDrain";
	iconName = "./SDrain";
	doColorShift = true;
	colorShiftColor = "0.471 0.471 0.471 1.000";

	 // Dynamic properties defined by the scripts
	image = SDrainImage;
	canDrop = true;
};


////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(SDrainImage)
{
   // Basic Item properties
   shapeFile = "base/data/shapes/hammer.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   //eyeOffset = "0.1 0.2 -0.55";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = false;

   eyeOffset = "0.7 1.2 -0.25";

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = SDrainItem;
   ammo = " ";
   projectile = SDrainProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = true;
   doRetraction = false;
   //raise your arm up or not
   armReady = true;

   //casing = " ";
   doColorShift = true;
   colorShiftColor = "0.471 0.471 0.471 1.000";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.5;
	stateTransitionOnTimeout[0]      = "Ready";
	stateSound[0]                    = swordDrawSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "PreFire";
	stateAllowImageChange[1]         = true;

	stateName[2]			= "PreFire";
	stateScript[2]                  = "onPreFire";
	stateAllowImageChange[2]        = false;
	stateTimeoutValue[2]            = 0.4;
	stateTransitionOnTimeout[2]     = "Fire";

	stateName[3]                    = "Fire";
	stateTransitionOnTimeout[3]     = "CheckFire";
	stateTimeoutValue[3]            = 0.2;
	stateFire[3]                    = true;
	stateAllowImageChange[3]        = false;
	stateSequence[3]                = "Fire";
	stateScript[3]                  = "onFire";
	stateWaitForTimeout[3]		= true;
	//stateTransitionOnTriggerUp[3]	= "StopFire";

	stateName[4]			= "CheckFire";
	stateTransitionOnTriggerUp[4]	= "StopFire";
	stateTransitionOnTriggerDown[4]	= "Fire";

	
	stateName[5]                    = "StopFire";
	stateTransitionOnTimeout[5]     = "Ready";
	stateTimeoutValue[5]            = 0.2;
	stateAllowImageChange[5]        = false;
	stateWaitForTimeout[5]		= true;
	stateSequence[5]                = "StopFire";
	stateScript[5]                  = "onStopFire";


};

function SDrainImage::onPreFire(%this, %obj, %slot)
{
	//messageAll( 'MsgClient', 'SDrain prefired!!!');
	//Parent::onFire(%this, %obj, %slot);
	%obj.playthread(2, armattack);
}

function SDrainImage::onStopFire(%this, %obj, %slot)
{	
	%obj.playthread(2, root);
	//messageAll( 'MsgClient', 'stopfire');
}







function SDrainProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{				
	if(!isobject(%col)){
		Parent::onCollision(%this, %obj, %col, %fade, %pos, %normal);
		return;
	}
	if(%col.getclassname() $= "Player" || %col.getclassname() $= "AIPlayer"){
		if(%obj.client.tdmteam == %col.client.tdmteam){
			return;
		}
		if(%obj.client.curclass $= "harvester"){
			//Parent::onCollision(%this, %obj, %col, %fade, %pos, %normal);
			%obj.client.player.drainedenergy+=5;
			%obj.client.player.setdamagelevel(%obj.client.player.getdamagelevel() - 5);
			servercmdUpStatusData(%obj.client);
		}
		if(%obj.client.curclass $= "fallen"){
			%obj.client.player.setdamagelevel(%obj.client.player.getdamagelevel() - 7);
			servercmdUpStatusData(%obj.client);
		}
			
		Parent::onCollision(%this, %obj, %col, %fade, %pos, %normal);
		return;
	}
	
	//Parent::onCollision(%this, %obj, %col, %fade, %pos, %normal);
}





















