//Sheal.cs




//projectile
//AddDamageType("Sheal",   '<bitmap:add-ons/ci/Sheal> %1',    '%2 <bitmap:add-ons/ci/Sheal> %1',1,1);
datablock ProjectileData(ShealProjectile)
{
   //projectileShapeName = "~/data/shapes/arrow.dts";
   directDamage        = 0;
   //directDamageType  = $DamageType::Sheal;
   //radiusDamageType  = $DamageType::Sheal;
   explosion           = wrenchExplosion;
   //particleEmitter     = as;

   muzzleVelocity      = 60;
   velInheritFactor    = 1;

   impactImpulse	     = 0;
   verticalImpulse	  = 0;

   armingDelay         = 0;
   lifetime            = 170;
   fadeDelay           = 100;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";
};


//////////
// item //
//////////
datablock ItemData(ShealItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "base/data/shapes/wrench.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "SHeal";
	iconName = "./Sheal";
	doColorShift = true;
	colorShiftColor = "0.671 0.471 0.471 1.000";

	 // Dynamic properties defined by the scripts
	image = ShealImage;
	canDrop = true;
};


////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(ShealImage)
{
   // Basic Item properties
   shapeFile = "base/data/shapes/wrench.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   //eyeOffset = "0.1 0.2 -0.55";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = false;

   eyeOffset = "0.7 1.2 -0.25";

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = ShealItem;
   ammo = " ";
   projectile = ShealProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = true;
   doRetraction = false;
   //raise your arm up or not
   armReady = true;

   //casing = " ";
   doColorShift = true;
   colorShiftColor = "0.871 0.671 0.471 1.000";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.5;
	stateTransitionOnTimeout[0]      = "Ready";
	stateSound[0]                    = swordDrawSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "PreFire";
	stateAllowImageChange[1]         = true;

	stateName[2]			= "PreFire";
	stateScript[2]                  = "onPreFire";
	stateAllowImageChange[2]        = false;
	stateTimeoutValue[2]            = 0.1;
	stateTransitionOnTimeout[2]     = "Fire";

	stateName[3]                    = "Fire";
	stateTransitionOnTimeout[3]     = "CheckFire";
	stateTimeoutValue[3]            = 1.0;
	stateFire[3]                    = true;
	stateAllowImageChange[3]        = false;
	stateSequence[3]                = "Fire";
	stateScript[3]                  = "onFire";
	stateWaitForTimeout[3]		= true;
	//stateTransitionOnTriggerUp[3]	= "StopFire";

	stateName[4]			= "CheckFire";
	stateTransitionOnTriggerUp[4]	= "StopFire";
	stateTransitionOnTriggerDown[4]	= "Fire";

	
	stateName[5]                    = "StopFire";
	stateTransitionOnTimeout[5]     = "Ready";
	stateTimeoutValue[5]            = 0.2;
	stateAllowImageChange[5]        = false;
	stateWaitForTimeout[5]		= true;
	stateSequence[5]                = "StopFire";
	stateScript[5]                  = "onStopFire";


};

function ShealImage::onPreFire(%this, %obj, %slot)
{
	//messageAll( 'MsgClient', 'Sheal prefired!!!');
	//Parent::onFire(%this, %obj, %slot);
	%obj.playthread(2, armattack);
}

function ShealImage::onStopFire(%this, %obj, %slot)
{	
	%obj.playthread(2, root);
	//messageAll( 'MsgClient', 'stopfire');
}

function ShealProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{				
	if(!isobject(%col)){
		return;
	}
	if(%col.getclassname() !$= "Player" && %col.getclassname() !$= "AIPlayer"){
		return;	
	}
	if(!%col.client.bl_id){return;}
	if(%col.getDamageLevel() > 0)//if they are damaged
	{
		if(!%obj.client.repairmult){
			%obj.client.repairmult = 5;
		}
		//echo(%obj.client.lastrepaired SPC %col.client.bl_id);
		if(%obj.client.lastrepaired $= %col.client.bl_id){
			%obj.client.repairmult+=1;
			if(%obj.client.player.drainedenergy && %obj.client.repairmult < 35){
				%obj.client.repairmult+=5;
				%obj.client.player.drainedenergy-=5;
				if(%obj.client.player.drainedenergy<=5){
					%obj.client.player.drainedenergy=0;
				}
			}
		}else{
			%obj.client.repairmult = 5;
		}
		if(%obj.client.repairmult>=40){
			%obj.client.repairmult=10;
		}
		%col.setDamageLevel(%col.getdamagelevel() - %obj.client.repairmult);
		%obj.client.playerheals+=%obj.client.repairmult;
		if(%obj.client.playerheals>=200){
			%obj.client.playerheals=0;
			%obj.client.incscore(1);
		}
		centerprint(%obj.client,"\c5(\c2" @ %col.getdatablock().maxdamage-%col.getdamagelevel() @ "\c5/\c2" @ %col.getdatablock().maxdamage @ "\c5)" SPC %obj.client.repairmult SPC "Healed:\c2" SPC %col.client.name SPC "\c5Drained Energy:\c2" SPC %obj.client.player.drainedenergy,4);
		centerprint(%col.client,"\c5(\c2" @ %col.getdatablock().maxdamage-%col.getdamagelevel() @ "\c5/\c2" @ %col.getdatablock().maxdamage @ "\c5)" SPC %obj.client.repairmult SPC "Healed by:\c2" SPC %obj.client.name,4);
		%obj.client.lastrepaired = %col.client.bl_id;	
		//echo(%obj.client.lastrepaired);
	}else{
		if(!%obj.client.repairmult){
			%obj.client.repairmult = 5;
		}
		//echo(%obj.client.lastrepaired SPC %col.client.bl_id);
		if(%obj.client.lastrepaired $= %col.client.bl_id){
			%obj.client.repairmult+=2;
		}else{
			%obj.client.repairmult = 5;
		}
		if(%obj.client.repairmult>40){
			%obj.client.repairmult=40;
		}
		%obj.client.lastrepaired = %col.client.bl_id;	
	}
	Parent::onCollision(%this, %obj, %col, %fade, %pos, %normal);
}
