//Sshotgun.cs
//exec("add-ons/blockrace/weapon_rpistol.cs");




datablock ParticleData(StrackerExplosionParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = -0.2;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 700;
	lifetimeVarianceMS   = 400;
	textureName          = "./exp1spark";
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "0.7 0.6 0.2 0.9";
	colors[1]     = "0.5 0.4 0.2 0.0";
	sizes[0]      = 0.45;
	sizes[1]      = 0.55;

	useInvAlpha = true;
};
datablock ParticleEmitterData(StrackerExplosionEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 5;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "StrackerExplosionParticle";
};

datablock ExplosionData(StrackerExplosion)
{
   //explosionShape = "";
	soundProfile = bulletHitSound;

   lifeTimeMS = 70;

   particleEmitter = StrackerExplosionEmitter;
   particleDensity = 10;
   particleRadius = 0.2;

   emitter[0] = SshotgunExplosionRingEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = false;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 0;
   lightEndRadius = 2;
   lightStartColor = "0.3 0.6 0.7";
   lightEndColor = "0 0 0";
   damageRadius = 2.0;
   radiusDamage = 5;

   impulseRadius = 1.0;
   impulseForce = 100;
};


AddDamageType("Stracker",   '%1\c1 died of explosive tracker rounds.',    '%2 \c1filled\c0 %1 \c1with tracker bullets.',0.5,1);
datablock ProjectileData(StrackerProjectile)
{
   projectileShapeName = "Add-ons/Weapon_Gun/bullet.dts";
   directDamage        = 3;
   directDamageType    = $DamageType::Sshotgun;
   radiusDamageType    = $DamageType::Sshotgun;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 400;
   verticalImpulse	  = 000;
   explosion           = StrackerExplosion;
   particleEmitter     = RbulletTrailEmitter;

   muzzleVelocity      = 200;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 2000;
   fadeDelay           = 1500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";
};


//////////
// item //
//////////
datablock ItemData(StrackerItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./shotgun1.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Stracker";
	iconName = "Add-ons/Weapon_Gun/gun";
	doColorShift = true;
	colorShiftColor = "0.70 0.75 0.75 1.000";

	 // Dynamic properties defined by the scripts
	image = StrackerImage;
	canDrop = true;
};


////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(StrackerImage)
{
   // Basic Item properties
   shapeFile = "./shotgun1.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = StrackerProjectile;
   projectileType = Projectile;

	casing = SshotgunShellDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = StrackerItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.15;
	stateTransitionOnTimeout[0]       = "Ready";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;
	stateSequence[1]	= "Ready";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Smoke";
	stateTimeoutValue[2]            = 0.02;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;
	stateEmitter[2]					= SshotgunFlashEmitter;
	stateEmitterTime[2]				= 0.08;
	stateEmitterNode[2]				= "muzzleNode";
	stateSound[2]					= gunShot1Sound;
	stateEjectShell[2]       = true;

	stateName[3] = "Smoke";
	stateEmitter[3]					= SshotgunSmokeEmitter;
	stateEmitterTime[3]				= 0.01;
	stateEmitterNode[3]				= "muzzleNode";
	stateTimeoutValue[3]            = 0.27;
	stateTransitionOnTimeout[3]     = "Reload";

	stateName[4]			= "Reload";
	stateSequence[4]                = "Reload";
	stateTransitionOnTriggerUp[4]     = "Ready";
	stateSequence[4]	= "Ready";

};

function StrackerImage::onFire(%this,%obj,%slot)
{
	%reloadtime="2500";
	if(!%obj.bulletloaded["tracker"]){%obj.bulletloaded["tracker"]=13;}
	if(!%obj.trackercritchance){%obj.trackercritchance=4;}
	if(%obj.trackerreloading){
		if(1 > %obj.bulletloaded["tracker"]-1){// || 2 > %obj.bulletloaded["tracker"]-1 && %obj.client.curclass$="fuser"
			return;
		}
		if(1 > %obj.bulletloaded["tracker"]-1){// || 2 > %obj.bulletloaded["tracker"]-1 && %obj.client.curclass$="harvester"
			return;
		}
		%obj.canceltrackerreloading=1;
		%obj.trackerreloading=0;
		cancel($trackerreload[%obj]);
		$trackerreload[%obj]=0;
	}
	if(1 > %obj.bulletloaded["tracker"]-1){// || 2 > %obj.bulletloaded["shotgun"]-1 && %obj.client.curclass$="fuser" || 2 > %obj.bulletloaded["shotgun"]-1 && %obj.client.curclass$="harvester"
		%obj.playThread(2, shiftdown);
		//centerprint(%obj.client,"Reloading...\c1" SPC %obj.bulletloaded["tracker"]-1 @ "\c0/\c1" @ 36 - %obj.bulletexpended["tracker"],200);
		%obj.trackerreloading=1;
		$trackerreload[%obj]=schedule(%reloadtime,0,"Strackerreload",%obj);
		return;
	}
	if(%obj.getDamagePercent() < 1.0)
		%obj.playThread(2, shiftAway);

	%projectile = %this.projectile;
	%typer="StrackerProjectile";
	%a=getrandom(1,%obj.trackercritchance+2);
	///if(%a==1 && $classon){
	//	%typer="SshotgunCritProjectile";
	//	%obj.shotguncritchance+=6;
	//}
	%spread = 0.0014;
	%pvec = %obj.client.player.getvelocity();
	if(getword(%pvec,0) + getword(%pvec,1) + getword(%pvec,2) > 1 || getword(%pvec,0) + getword(%pvec,1) + getword(%pvec,2) < -1){
		%spread += 0.0008;
	}else{
		%spread -= 0.0008;
	}
	%shellcount=1;
	%scale="1 1 1";
	%obj.bulletloaded["tracker"]-=1;
	centerprint(%obj.client,"\c0Shots left:\c1" SPC %obj.bulletloaded["tracker"]-1 @ "\c0/\c1" @ 36 - %obj.bulletexpended["tracker"],400);

	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity+%bonus);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);
		

		%p = new (%this.projectileType)()
		{
			dataBlock = %typer;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		%p.setscale(%scale);
		MissionCleanup.add(%p);
	}

	if(1 > %obj.bulletloaded["tracker"]-1){
		if(!%obj.trackerreloading&&$trackerreload[%obj]==0){
			%obj.playThread(2, shiftdown);
			centerprint(%obj.client,"Reloading...\c1" SPC %obj.bulletloaded["tracker"]-1 @ "\c0/\c1" @ 36 - %obj.bulletexpended["tracker"],200);
			%obj.trackerreloading=1;
			$trackerreload[%obj]=schedule(%reloadtime,0,"Strackerreload",%obj);
		}
	}
	return %p;
	

}

function Strackerreload(%obj){
	if(!isobject(%obj)||%obj.getdamagelevel() >= %obj.getdatablock().maxdamage){
		return;
	}
	if(%obj.canceltrackerreloading){
		%obj.canceltrackerreloading=0;
	}
	if(%obj.getmountedimage(0)!$=nametoid("Strackerimage")){
		%obj.canceltrackerreloading=1;
		%obj.trackercritchance-=2;
		if(%obj.trackercritchance<4){
			%obj.trackercritchance=4;
		}
		%obj.trackerreloading=0;
		cancel($trackerreload[%obj]);
		$trackerreload[%obj]=0;
		return;
	}
	if(%obj.bulletexpended["tracker"] >= 36){
		%obj.canceltrackerreloading=1;
		%obj.trackercritchance-=2;
		if(%obj.trackercritchance<4){
			%obj.trackercritchance=4;
		}
		%obj.trackerreloading=0;
		cancel($trackerreload[%obj]);
		$trackerreload[%obj]=0;
		centerprint(%obj.client,"No ammo...\c1" SPC %obj.bulletloaded["tracker"]-1 @ "\c0/\c1" @ 36 - %obj.bulletexpended["tracker"],200);
		return;
	}
	%obj.playThread(2, shiftright);
	%reloadtime="50";
	%obj.bulletloaded["tracker"]+=1;
	%obj.bulletexpended["tracker"]++;
	%obj.trackershellsfired--;
	if(%obj.trackershellsfired<0){
		%obj.trackershellsfired=0;	
	}
	centerprint(%obj.client,"Reloading...\c1" SPC %obj.bulletloaded["tracker"]-1 @ "\c0/\c1" @ 36 - %obj.bulletexpended["tracker"],200);
	if(%obj.bulletloaded["tracker"] < 13){
		$trackerreload[%obj]=schedule(%reloadtime,0,"Strackerreload",%obj);
	}else{
		%obj.trackercritchance-=6;
		if(%obj.trackercritchance<4){
			%obj.trackercritchance=4;
		}
		%obj.trackerreloading=0;
		$trackerreload[%obj]=0;
	}
}


package trackermountreload
{
function StrackerImage::onMount(%this,%obj,%slot)
{
	if(!%obj.client.player.bulletloaded["tracker"]){%obj.client.player.bulletloaded["tracker"]=13;}
	centerprint(%obj.client,"Ammo...\c1" SPC %obj.client.player.bulletloaded["tracker"]-1 @ "\c0/\c1" @ 36 - %obj.client.player.bulletexpended["tracker"],200);
	if(1 > %obj.client.player.bulletloaded["tracker"]-1){
		if(!%obj.client.player.trackerreloading&&$trackerreload[%obj.client.player]==0){
			%obj.client.player.playThread(2, shiftdown);
			centerprint(%obj.client,"Reloading...\c1" SPC %obj.client.player.bulletloaded["tracker"]-1 @ "\c0/\c1" @ 36 - %obj.client.player.bulletexpended["tracker"],200);
			%obj.client.player.trackerreloading=1;
			$trackerreload[%obj.client.player]=schedule(2500,0,"Strackerreload",%obj.client.player);
		}
	}
	parent::onMount(%this,%obj,%slot);
}


};
activatepackage(trackermountreload);


$bulletloadedmax["tracker"]=36;


function StrackerProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{			
	if(!isobject(%col)){
		Parent::onCollision(%this, %obj, %col, %fade, %pos, %normal);
		return;
	}
	if(%col.getclassname() $= "Player" || %col.getclassname() $= "AIPlayer"){
		%colds=vectordist(%obj.client.player.gettransform(),%col.gettransform());
		//announce(%colds);
		if(%colds<36){
			%cxyz=%col.getposition();
			%cx=getword(%cxyz,0);%cy=getword(%cxyz,1);%cz=getword(%cxyz,2);
			%oxyz=%obj.client.player.getposition();
			%ox=getword(%oxyz,0);%oy=getword(%oxyz,1);%oz=getword(%oxyz,2);
			if(%colds<36){
				%changevaluepos=6;
				%changevalueneg=-6;
			}
			if(%colds<30){
				%changevaluepos=5;
				%changevalueneg=-5;
			}
			if(%colds<24){
				%changevaluepos=4;
				%changevalueneg=-4;
			}
			if(%colds<18){
				%changevaluepos=3;
				%changevalueneg=-3;
			}
			if(%colds<12){
				%changevaluepos=2;
				%changevalueneg=-2;
			}
			if(%colds<6){
				%changevaluepos=1;
				%changevalueneg=-1;
			}
			
			if(%cx > %ox){
				%x_change=%changevaluepos;
				if(%cx - %ox < %changevaluepos){
					%x_change=%cx-%ox;
				}
			}
			if(%cy > %oy){
				%y_change=%changevaluepos;
				if(%cy - %oy < %changevaluepos){
					%y_change=%cy-%oy;
				}
			}
			if(%cz > %oz){
				%z_change=%changevaluepos;
				if(%cz - %oz < %changevaluepos){
					%z_change=%cz-%oz;
				}
			}
			if(%cx < %ox){
				%x_change=%changevalueneg;
				if(%cx - %ox > %changevalueneg){
					%x_change=%cx-%ox;
				}
			}
			if(%cy < %oy){
				%y_change=%changevalueneg;
				if(%cy - %oy > %changevalueneg){
					%y_change=%cy-%oy;
				}
			}
			if(%cz < %oz){
				%z_change=%changevalueneg;
				if(%cz - %oz > %changevalueneg){
					%z_change=%cz-%oz;
				}
			}
			%obj.client.player.setvelocity(vectoradd(%obj.client.player.getvelocity(),%x_change SPC %y_change SPC %z_change));
			%col.setvelocity(vectoradd(%col.getvelocity(),-1 * %x_change SPC -1 * %y_change SPC -1 * %z_change));
			//Parent::onCollision(%this, %obj, %col, %fade, %pos, %normal);
		}else{
			bottomprint(%obj.client,"Tip: Tracker can not track that far away.",3);
		}
		//bottomprint(%client,"Tip: Shotgun does less damage at a distance",3);
		Parent::onCollision(%this, %obj, %col, %fade, %pos, %normal);
		return;
	}
	
	//Parent::onCollision(%this, %obj, %col, %fade, %pos, %normal);
}

